SystemOrganization addCategory: #SwikiToTinyWiki!

!TWFolder methodsFor: '*swikitotinywiki' stamp: 'chc 1/8/2019 10:10'!
initializeHome
	| page |
	page := TWPage title: self title.
	page document addFirst: STTModel document.
	self add: page! !

!TWFolder methodsFor: '*swikitotinywiki' stamp: 'chc 10/16/2018 11:15'!
swikihome
	^self at: 'About AniAniWeb'! !

!TWFolder methodsFor: '*swikitotinywiki' stamp: 'chc 11/21/2018 08:52'!
title
	^'Home'! !

WAComponent subclass: #STTModel
	instanceVariableNames: ''
	classVariableNames: 'Document Folder'
	poolDictionaries: ''
	category: 'SwikiToTinyWiki'!

!STTModel commentStamp: 'al-loader 9/19/2018 08:45' prior: 0!
I am a model for TinyWiki containting Swiki XML files converted into a TWDocument. I contain an instance fed into TWWiki class>>#on: !

!STTModel class methodsFor: 'as yet unclassified' stamp: 'chc 8/1/2018 11:14'!
document 
	^Document! !

!STTModel class methodsFor: 'as yet unclassified' stamp: 'chc 8/1/2018 11:16'!
document: aTWDocument 
	Document := aTWDocument! !

!STTModel class methodsFor: 'as yet unclassified' stamp: 'al-loader 9/19/2018 08:46'!
folder
	^Folder! !

!STTModel class methodsFor: 'as yet unclassified' stamp: 'al-loader 9/19/2018 08:45'!
folder: aTWFolder 
	Folder := aTWFolder! !

WAComponent subclass: #STTTinyWiki
	instanceVariableNames: 'wiki'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwikiToTinyWiki'!

!STTTinyWiki commentStamp: 'chc 7/17/2018 18:39' prior: 0!
This is a wrapper class to make TinyWiki registerable as a Seaside app on its own instead of being a component in SqueakSource!

!STTTinyWiki methodsFor: 'as yet unclassified' stamp: 'chc 8/1/2015 22:34'!
children
	^Array with: wiki! !

!STTTinyWiki methodsFor: 'as yet unclassified' stamp: 'chc 1/8/2019 10:10'!
initialize
	super initialize.
	"wiki := TWWiki example"
	wiki := TWWiki on: STTModel folder! !

!STTTinyWiki methodsFor: 'as yet unclassified' stamp: 'chc 11/23/2018 08:36'!
renderContentOn: html
	html paragraph: 'This is Lukas Rengli''s TinyWiki from SqueakSource'.
	html render: wiki! !

Object subclass: #STTFileConverter
	instanceVariableNames: 'pagename pagetext merged'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SwikiToTinyWiki'!

!STTFileConverter commentStamp: 'chc 1/8/2019 10:12' prior: 0!
I convert Swiki XML files in the /swiki/refs/pages folder to TWPage instances used by the TinyWiki Visitor to render Swiki content in TinyWiki

ivars: 
filenumber: file number as key, page name as value
pagename: file number as key, page text as value
merged: page name as key, page text as value!

!STTFileConverter class methodsFor: 'as yet unclassified' stamp: 'al-loader 9/6/2018 09:45'!
tinywiki
	"Created a TWFolder for TinyWiki used in SqueakSource"
	self new tinywiki! !

!STTFileConverter methodsFor: 'start-here' stamp: 'al-loader 9/17/2018 07:35'!
convert
	self convert: 'pages'! !

!STTFileConverter methodsFor: 'start-here' stamp: 'chc 10/3/2018 09:20'!
convert: aDirectory
	self getFileNumber. 
	self getPageText.
	self mergeDictionaries.
	self swapLinkNumbers.
	self prefixPageName! !

!STTFileConverter methodsFor: 'xmlparsing' stamp: 'chc 7/20/2018 12:39'!
fileName: aFileNumber
	"Get the name of the file from inside the file at the <name>foo</name> tag"
	^((( XMLDOMParser parseDocumentFrom: ((FileStream readOnlyFileNamed: 'pages/' , aFileNumber , '.xml') contents) readStream) elementsAndContents first) elementAt: 'name') contents first! !

!STTFileConverter methodsFor: 'convertion' stamp: 'al-loader 9/7/2018 08:18'!
getFileNumber
		| key filenames |
"The names of each file is a number. Make that the key of the filenumber dictionary"
	filenames := (FileDirectory default directoryNamed: 'pages') fileNames.
	filenames do: [:ea|
		key := (ea findTokens: '.') first.
		pagename at: key put: (self fileName: key)]	
	
	! !

!STTFileConverter methodsFor: 'convertion' stamp: 'al-loader 9/7/2018 08:16'!
getPageText
			| key filenames |
"Replace the placeholder string in the pagename dictionary values with the wiki text for each page from the file"
	filenames := (FileDirectory default directoryNamed: 'pages') fileNames.
	filenames do: [:ea|
		key := (ea findTokens: '.') first.
		pagetext at: key put: (self pageText: key)]	
	! !

!STTFileConverter methodsFor: 'as yet unclassified' stamp: 'al-loader 9/7/2018 08:18'!
initialize
	pagename := Dictionary new. 
	pagetext := Dictionary new. 
	merged := Dictionary new! !

!STTFileConverter methodsFor: 'convertion' stamp: 'chc 10/1/2018 09:03'!
mergeDictionaries
	"Take values of filenumber as keys and values of pagenumber in new dictionary with page name: page text"
	|keys values|
	keys := pagename values. 
	values := pagetext values.
	1 to: keys size do: [:i|
		merged at: (keys at: i) string
			 put: (values at: i) string] ! !

!STTFileConverter methodsFor: 'accessing' stamp: 'chc 7/31/2018 09:26'!
merged
	^ merged! !

!STTFileConverter methodsFor: 'accessing' stamp: 'chc 7/31/2018 09:26'!
merged: anObject
	merged := anObject! !

!STTFileConverter methodsFor: 'xmlparsing' stamp: 'chc 7/23/2018 10:24'!
pageText: aFileNumber
	"Get the XML text node string"
	|filecontents stream textnode|
	filecontents :=(FileStream readOnlyFileNamed: 'pages/' , aFileNumber , '.xml') contents.
	stream := XMLDOMParser parseDocumentFrom: filecontents readStream.
	textnode := (stream elementsAndContents first) elementAt: 'text'.
	^textnode contents first 
	! !

!STTFileConverter methodsFor: 'accessing' stamp: 'al-loader 9/7/2018 08:17'!
pagename
	^ pagetext! !

!STTFileConverter methodsFor: 'accessing' stamp: 'al-loader 9/7/2018 08:17'!
pagename: anObject
	pagetext := anObject! !

!STTFileConverter methodsFor: 'convertion' stamp: 'chc 10/3/2018 09:21'!
prefixPageName
	merged keysAndValuesDo: [:key :value|
		"prefix the value string with the page name"
		merged at: key string put: (key , Character cr , value)]! !

!STTFileConverter methodsFor: 'convertion' stamp: 'al-loader 9/17/2018 07:37'!
swapLinkNumbers
	"replace the page numbers in the links for page names"
	merged keysAndValuesDo: [:key :value||stringbits newstring|
		"segment string removing delimiter"
		stringbits := value string findTokens: #($*).
		"replace possible numbers with page names"
		stringbits doWithIndex: [:stringbit :index| 
			([ stringbit asNumber ] on: Error do: []) notNil
				ifTrue: [ stringbits at: index put: '*' , (pagename at: stringbit) , '*'].
		"concatenate back together"
		newstring := stringbits inject: '' into: [:pa :each| pa , each ].
		merged at: key put: newstring 
		]]! !

!STTFileConverter methodsFor: 'destinations' stamp: 'chc 11/21/2018 08:51'!
tinywiki
	|folder|
	"All this method does is set up Lukas's TWParser>>#parse: where the magic happens"
	self convert.
	folder := TWFolder new. 
	merged keysAndValuesDo: [:k :v | |page|
			page := TWPage title: k.
			page document addFirst: (TWParser parse: v string).
			folder add: page].
	^folder
	! !

!TWWiki methodsFor: '*swikitotinywiki' stamp: 'chc 10/16/2018 11:16'!
home
	self visitor: self model home viewer on: self model swikihome! !

!TWWiki methodsFor: '*swikitotinywiki' stamp: 'chc 10/19/2018 08:29'!
setModel: anObject
	self view: (model := anObject) swikihome! !
